declare const _default: import("vue").DefineComponent<{
    readonly options: import("vue").PropType<{
        [prop: string]: any;
        slot?: string | undefined;
        action?: boolean | undefined;
        actionConfig?: {
            editText?: string | undefined;
            deleteText?: string | undefined;
            showEdit?: boolean | undefined;
            showDelete?: boolean | undefined;
            custom?: ((list: (import("../..").CustomElement | import("vue").DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>)[], scope: any) => (import("../..").CustomElement | import("vue").DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>)[]) | undefined;
        } | undefined;
        editable?: boolean | undefined;
        editableConfig?: {
            showEnter?: boolean | undefined;
            showClose?: boolean | undefined;
            custom?: ((list: (import("../..").CustomElement | import("vue").DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>)[], scope: any, isEdit: import("vue").Ref<boolean>) => (import("../..").CustomElement | import("vue").DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>)[]) | undefined;
        } | undefined;
        type?: "selection" | "index" | "expand" | undefined;
        index?: number | ((index: number) => void) | undefined;
        label?: string | undefined;
        columnKey?: string | undefined;
        prop?: string | undefined;
        width?: string | number | undefined;
        minWidth?: string | number | undefined;
        fixed?: true | "left" | "right" | undefined;
        renderHeader?(data: {
            column: any;
            $index: number;
        }): void;
        sortable?: boolean | "custom" | undefined;
        sortMethod?(a: number, b: number): number;
        sortBy?: ((row: any, index: number) => string | void | any[]) | undefined;
        sortOrders?: any[] | undefined;
        resizable?: boolean | undefined;
        formatter?(row: any, column: any, cellValue: any, index: number): void;
        showOverflowTooltip?: boolean | undefined;
        align?: "left" | "right" | "center" | undefined;
        headerAlign?: "left" | "right" | "center" | undefined;
        className?: string | undefined;
        labelClassName?: string | undefined;
        selectable?(row: any, index: number): boolean;
        reserveSelection?: boolean | undefined;
        filters?: {
            text: any;
            value: any;
        }[] | undefined;
        filterPlacement?: "left" | "right" | "top" | "top-start" | "top-end" | "bottom" | "bottom-start" | "bottom-end" | "left-start" | "left-end" | "right-start" | "right-end" | undefined;
        filterMultiple?: boolean | undefined;
        filterMethod?(value: any, row: any, column: any): void;
        filteredValue?: any[] | undefined;
    }[]>;
    readonly editRow: BooleanConstructor;
    readonly showPagination: {
        readonly type: BooleanConstructor;
    };
    readonly server: {
        readonly type: import("vue").PropType<import("axios").AxiosStatic>;
        readonly default: import("axios").AxiosStatic;
    };
    readonly getUrl: StringConstructor;
    readonly withPage: {
        readonly type: import("vue").PropType<string | boolean>;
        readonly default: null;
    };
    readonly withPagePath: StringConstructor;
    readonly withQuery: ObjectConstructor;
    readonly withQueryPath: StringConstructor;
    readonly stringify: BooleanConstructor;
    readonly getConfig: {
        readonly type: import("vue").PropType<import("axios").AxiosRequestConfig>;
        readonly default: () => {
            method: string;
        };
    };
    readonly replaceFields: {
        readonly type: import("vue").PropType<{
            pageSize?: string | undefined;
            currentPage?: string | undefined;
        }>;
        readonly default: () => {
            pageSize: string;
            currentPage: string;
        };
    };
    readonly dataPath: {
        readonly type: StringConstructor;
        readonly default: "data.data";
    };
    readonly totalPath: {
        readonly type: StringConstructor;
        readonly default: "data.total";
    };
    readonly showLoadInGet: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly elementLoadingText: {
        readonly type: StringConstructor;
        readonly default: "正在加载中...";
    };
    readonly elLoadingTextTimeout: {
        readonly type: NumberConstructor;
        readonly default: 8000;
    };
    readonly elLoadingTextTimeoutText: {
        readonly type: StringConstructor;
        readonly default: "数据加载较慢，请耐心等待...";
    };
    readonly emptyTip: {
        readonly type: StringConstructor;
        readonly default: "正在加载中...";
    };
    readonly emptyTipTimeout: {
        readonly type: NumberConstructor;
        readonly default: 8000;
    };
    readonly emptyTipTimeoutText: {
        readonly type: StringConstructor;
        readonly default: "数据加载较慢，请耐心等待...";
    };
    readonly defaultCurrentPage: NumberConstructor;
    readonly defaultPageSize: NumberConstructor;
}, () => JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("edit" | "delete" | "confirmEditRow" | "cancelEditRow" | "confirmEditCell" | "cancelEditCell" | "beforeGetData" | "afterGetData" | "failToGetData")[], "edit" | "delete" | "confirmEditRow" | "cancelEditRow" | "confirmEditCell" | "cancelEditCell" | "beforeGetData" | "afterGetData" | "failToGetData", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    readonly options: import("vue").PropType<{
        [prop: string]: any;
        slot?: string | undefined;
        action?: boolean | undefined;
        actionConfig?: {
            editText?: string | undefined;
            deleteText?: string | undefined;
            showEdit?: boolean | undefined;
            showDelete?: boolean | undefined;
            custom?: ((list: (import("../..").CustomElement | import("vue").DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>)[], scope: any) => (import("../..").CustomElement | import("vue").DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>)[]) | undefined;
        } | undefined;
        editable?: boolean | undefined;
        editableConfig?: {
            showEnter?: boolean | undefined;
            showClose?: boolean | undefined;
            custom?: ((list: (import("../..").CustomElement | import("vue").DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>)[], scope: any, isEdit: import("vue").Ref<boolean>) => (import("../..").CustomElement | import("vue").DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>)[]) | undefined;
        } | undefined;
        type?: "selection" | "index" | "expand" | undefined;
        index?: number | ((index: number) => void) | undefined;
        label?: string | undefined;
        columnKey?: string | undefined;
        prop?: string | undefined;
        width?: string | number | undefined;
        minWidth?: string | number | undefined;
        fixed?: true | "left" | "right" | undefined;
        renderHeader?(data: {
            column: any;
            $index: number;
        }): void;
        sortable?: boolean | "custom" | undefined;
        sortMethod?(a: number, b: number): number;
        sortBy?: ((row: any, index: number) => string | void | any[]) | undefined;
        sortOrders?: any[] | undefined;
        resizable?: boolean | undefined;
        formatter?(row: any, column: any, cellValue: any, index: number): void;
        showOverflowTooltip?: boolean | undefined;
        align?: "left" | "right" | "center" | undefined;
        headerAlign?: "left" | "right" | "center" | undefined;
        className?: string | undefined;
        labelClassName?: string | undefined;
        selectable?(row: any, index: number): boolean;
        reserveSelection?: boolean | undefined;
        filters?: {
            text: any;
            value: any;
        }[] | undefined;
        filterPlacement?: "left" | "right" | "top" | "top-start" | "top-end" | "bottom" | "bottom-start" | "bottom-end" | "left-start" | "left-end" | "right-start" | "right-end" | undefined;
        filterMultiple?: boolean | undefined;
        filterMethod?(value: any, row: any, column: any): void;
        filteredValue?: any[] | undefined;
    }[]>;
    readonly editRow: BooleanConstructor;
    readonly showPagination: {
        readonly type: BooleanConstructor;
    };
    readonly server: {
        readonly type: import("vue").PropType<import("axios").AxiosStatic>;
        readonly default: import("axios").AxiosStatic;
    };
    readonly getUrl: StringConstructor;
    readonly withPage: {
        readonly type: import("vue").PropType<string | boolean>;
        readonly default: null;
    };
    readonly withPagePath: StringConstructor;
    readonly withQuery: ObjectConstructor;
    readonly withQueryPath: StringConstructor;
    readonly stringify: BooleanConstructor;
    readonly getConfig: {
        readonly type: import("vue").PropType<import("axios").AxiosRequestConfig>;
        readonly default: () => {
            method: string;
        };
    };
    readonly replaceFields: {
        readonly type: import("vue").PropType<{
            pageSize?: string | undefined;
            currentPage?: string | undefined;
        }>;
        readonly default: () => {
            pageSize: string;
            currentPage: string;
        };
    };
    readonly dataPath: {
        readonly type: StringConstructor;
        readonly default: "data.data";
    };
    readonly totalPath: {
        readonly type: StringConstructor;
        readonly default: "data.total";
    };
    readonly showLoadInGet: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly elementLoadingText: {
        readonly type: StringConstructor;
        readonly default: "正在加载中...";
    };
    readonly elLoadingTextTimeout: {
        readonly type: NumberConstructor;
        readonly default: 8000;
    };
    readonly elLoadingTextTimeoutText: {
        readonly type: StringConstructor;
        readonly default: "数据加载较慢，请耐心等待...";
    };
    readonly emptyTip: {
        readonly type: StringConstructor;
        readonly default: "正在加载中...";
    };
    readonly emptyTipTimeout: {
        readonly type: NumberConstructor;
        readonly default: 8000;
    };
    readonly emptyTipTimeoutText: {
        readonly type: StringConstructor;
        readonly default: "数据加载较慢，请耐心等待...";
    };
    readonly defaultCurrentPage: NumberConstructor;
    readonly defaultPageSize: NumberConstructor;
}>> & {
    onEdit?: ((...args: any[]) => any) | undefined;
    onDelete?: ((...args: any[]) => any) | undefined;
    onConfirmEditRow?: ((...args: any[]) => any) | undefined;
    onCancelEditRow?: ((...args: any[]) => any) | undefined;
    onConfirmEditCell?: ((...args: any[]) => any) | undefined;
    onCancelEditCell?: ((...args: any[]) => any) | undefined;
    onBeforeGetData?: ((...args: any[]) => any) | undefined;
    onAfterGetData?: ((...args: any[]) => any) | undefined;
    onFailToGetData?: ((...args: any[]) => any) | undefined;
}, {
    readonly editRow: boolean;
    readonly showPagination: boolean;
    readonly server: import("axios").AxiosStatic;
    readonly withPage: string | boolean;
    readonly stringify: boolean;
    readonly getConfig: import("axios").AxiosRequestConfig;
    readonly replaceFields: {
        pageSize?: string | undefined;
        currentPage?: string | undefined;
    };
    readonly dataPath: string;
    readonly totalPath: string;
    readonly showLoadInGet: boolean;
    readonly elementLoadingText: string;
    readonly elLoadingTextTimeout: number;
    readonly elLoadingTextTimeoutText: string;
    readonly emptyTip: string;
    readonly emptyTipTimeout: number;
    readonly emptyTipTimeoutText: string;
}>;
export default _default;
