import { defineComponent as ee, ref as r, onMounted as M, withDirectives as te, createVNode as o, mergeProps as G, resolveComponent as y, resolveDirective as ae, createTextVNode as le, nextTick as $, isVNode as ie, toRef as V, Fragment as ne } from "vue";
import ue from "qs";
import "../../selectArea/index.js";
import "../../selectDate/index.js";
import "../../selectTime/index.js";
import "../../trend/index.js";
import "../../progress/index.js";
import "../../notification/index.js";
import "../index.js";
import { KCustomElement as J } from "../../customElement/index.js";
import { tableProps as oe } from "./props.js";
import { Check as de, Close as re, Edit as ce } from "@element-plus/icons-vue";
import { createNamespacs as me, getValue as A } from "@tomiaa/utils";
import "../../packages/theme-chalk/lib/vue3-components/table.js";
function ve(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !ie(e);
}
const P = me("table"), ke = ee({
  name: "KTable",
  props: oe,
  emits: [
    "edit",
    "delete",
    "confirmEditRow",
    "cancelEditRow",
    "confirmEditCell",
    "cancelEditCell",
    "beforeGetData",
    "afterGetData",
    "failToGetData"
  ],
  setup(e, {
    attrs: z,
    slots: N,
    emit: m,
    expose: H
  }) {
    const S = r(""), j = r(""), {
      append: _,
      empty: B = () => e.emptyTip && T.value && S.value,
      page: W,
      editControlIcon: R,
      editIcon: O
    } = N, s = r({}), h = r({}), X = (c) => c == null ? void 0 : c.map((E) => {
      const {
        slot: F,
        action: w,
        actionConfig: t,
        editable: C,
        editableConfig: n,
        ...f
      } = E, v = {
        header: N.header,
        default: () => o("div", null, [le("dasdlk")])
      };
      if (e.editRow && (v.default = (l) => {
        const {
          row: i,
          column: a,
          $index: d
        } = l;
        return o("div", {
          class: [P.e("editable"), P.is("editable", s.value[d])]
        }, [s.value[d] ? o(y("el-input"), {
          size: "small",
          modelValue: h.value[d][a.property],
          "onUpdate:modelValue": (g) => h.value[d][a.property] = g
        }, null) : i[a.property]]);
      }), (w || t) && (v.default = (l) => {
        const {
          $index: i,
          row: a
        } = l;
        let d = [{
          tag: "el-button",
          size: "small",
          "v-if": t == null ? void 0 : t.showEdit,
          onClick: () => {
            if (e.editRow) {
              if (s.value[i]) {
                Object.assign(l.row, h.value[i]), delete h.value[i], delete s.value[i], m("confirmEditRow", l);
                return;
              }
              h.value[i] = JSON.parse(JSON.stringify(a)), s.value[i] = !0;
            }
            m("edit", l);
          },
          children: s.value[i] ? "\u786E\u5B9A" : (t == null ? void 0 : t.editText) || "\u7F16\u8F91"
        }, {
          tag: "el-button",
          size: "small",
          type: "danger",
          "v-if": t == null ? void 0 : t.showDelete,
          onClick: () => {
            if (e.editRow) {
              delete h.value[i], delete s.value[i], m("cancelEditRow", l);
              return;
            }
            m("delete", l);
          },
          children: s.value[i] ? "\u53D6\u6D88" : (t == null ? void 0 : t.deleteText) || "\u5220\u9664"
        }];
        return t != null && t.custom && (d = t.custom(d, l)), o(J, {
          list: d
        }, null);
      }), C || n) {
        const l = r({}), i = r({});
        v.default = (a) => {
          const {
            row: d,
            column: g,
            $index: Z
          } = a, u = g.id + Z, K = () => {
            delete i.value[u], delete l.value[u];
          };
          let L = [{
            tag: "el-icon",
            color: "var(--el-color-success)",
            size: "1.2em",
            "v-if": n == null ? void 0 : n.showEnter,
            onClick() {
              d[g.property] = i.value[u], K(), m("confirmEditCell", a);
            },
            children: de
          }, {
            tag: "el-icon",
            size: "1.2em",
            color: "var(--el-color-danger)",
            "v-if": n == null ? void 0 : n.showClose,
            onClick() {
              K(), m("cancelEditCell", a);
            },
            children: re
          }];
          return n != null && n.custom && (L = n.custom(L, a, V(l.value, u))), o("div", {
            class: [P.e("editable"), P.is("editable", l.value[u])]
          }, [l.value[u] ? o(y("el-input"), {
            size: "small",
            modelValue: i.value[u],
            "onUpdate:modelValue": (p) => i.value[u] = p
          }, null) : d[g.property], l.value[u] ? o(ne, null, [
            (R == null ? void 0 : R({
              ...a,
              isEdit: V(l.value, u)
            })) || o(J, {
              list: L
            }, null)
          ]) : O ? o("span", {
            onClick: () => {
              i.value[u] = d[g.property];
            }
          }, [O({
            ...a,
            isEdit: V(l.value, u)
          })]) : o(y("el-icon"), {
            size: "1.2em",
            onClick: () => {
              i.value[u] = d[g.property], l.value[u] = !l.value[u];
            }
          }, {
            default: () => [o(ce, null, null)]
          })]);
        };
      }
      return o(y("el-table-column"), f, ve(v) ? v : {
        default: () => [v]
      });
    }), Y = () => o(y("el-pagination"), G({
      class: P.b("pagination"),
      defaultCurrentPage: e.defaultCurrentPage,
      defaultPageSize: e.defaultPageSize,
      currentPage: q.value,
      pageSize: I.value,
      total: U.value,
      ref: x,
      layout: "->,sizes,prev,pager,next,jumper,total",
      "hide-on-single-page": !0
    }, z, {
      "onUpdate:currentPage": async (c) => {
        q.value = c, await $(), b();
      },
      "onUpdate:page-size": async (c) => {
        I.value = c, await $(), b();
      }
    }), {
      default: W
    }), x = r(), Q = r(), k = r(null), U = r(0), q = r(e.defaultCurrentPage || 1), I = r(e.defaultPageSize || 10), T = r(!1), b = () => {
      var v, l, i;
      T.value = !0, k.value = null;
      let c;
      e.emptyTip && (S.value = e.emptyTip, clearTimeout(c), c = setTimeout(() => {
        S.value = e.emptyTipTimeoutText;
      }, e.emptyTipTimeout));
      let E;
      e.elLoadingTextTimeoutText && (j.value = e.elementLoadingText, clearTimeout(E), setTimeout(() => {
        const a = document.querySelector(".el-loading-text");
        a && (a.innerHTML = e.elLoadingTextTimeoutText);
      }, e.elLoadingTextTimeout));
      const F = e.server, w = {
        [((v = e.replaceFields) == null ? void 0 : v.pageSize) || "pageSize"]: x.value.pageSize,
        [((l = e.replaceFields) == null ? void 0 : l.currentPage) || "currentPage"]: x.value.currentPage
      }, t = {}, C = {
        get: "params",
        post: "data"
      }, n = ((i = e.getConfig) == null ? void 0 : i.method) && C[e.getConfig.method.toLocaleLowerCase()];
      if (e.withPage !== !1 && (e.withPage && typeof e.withPage == "string" ? t[e.withPage] = e.withPagePath ? {
        [e.withPagePath]: w
      } : w : n && (t[n] = e.withPagePath ? {
        [e.withPagePath]: w
      } : w)), e.withQuery) {
        t[n] || (t[n] = {});
        const a = e.withQueryPath ? {
          [e.withQueryPath]: e.withQuery
        } : e.withQuery;
        t[n] = {
          ...t[n],
          ...a
        };
      }
      const f = {
        url: e.getUrl,
        ...t,
        ...e.getConfig
      };
      e.stringify && f.data && (f.data = ue.stringify(f.data)), m("beforeGetData", f), F(f).then((a) => {
        m("afterGetData", a), k.value = A(e.dataPath, a), U.value = A(e.totalPath, a);
      }).catch((a) => {
        m("failToGetData", a);
      }).finally(() => {
        clearTimeout(c), clearTimeout(E), T.value = !1;
      });
    };
    e.showPagination && M(b);
    const D = {
      getData: b
    };
    return M(() => {
      D.elPagination = x.value, D.elTable = Q.value;
    }), H(D), () => te(o("div", G({
      class: P.b(),
      "element-loading-text": j.value
    }, z), [o(y("el-table"), G({
      data: k.value,
      ref: Q
    }, z), {
      default: () => [X(e.options)],
      append: _,
      empty: B
    }), e.showPagination && Y(), e.showLoadInGet && T.value]), [[ae("loading"), e.showLoadInGet && T.value]]);
  }
});
export {
  ke as default
};
